import java.util.logging.Logger;
import java.util.logging.Level;
import java.io.IOException;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import javax.net.ssl.SSLSocket;
import java.util.Arrays;

class SSLEchoConnectionHandler implements Runnable {

    private final static Logger logger = Logger.getLogger(SSLEchoConnectionHandler.class.getName());

    private SSLSocket socket;

    SSLEchoConnectionHandler(SSLSocket socket) {
        this.socket = socket;
    }

    @Override
    public void run() {
        try {
            BufferedInputStream bis = new BufferedInputStream(socket.getInputStream());
            BufferedOutputStream bos = new BufferedOutputStream(socket.getOutputStream());

            byte[] buffer = new byte[1024];
            int read;
            while ((read = bis.read(buffer)) > 0) {
                bos.write(buffer, 0, read);
                logger.info("Recieved " + read + " bytes: " + Arrays.toString(Arrays.copyOf(buffer, read)));
                bos.flush();
            }

            //socket.close();
        } catch(IOException e) {
            logger.log(Level.INFO, "IOException occured during handling client connection", e);
        }
    }
}