import java.util.ArrayList;
import java.net.InetAddress;
import java.net.ServerSocket;
import java.net.UnknownHostException;
import java.util.logging.Level;
import java.util.logging.Logger;

class Utils {

    private final static Logger logger = Logger.getLogger(Utils.class.getName());

    static String[] filterStringArray(String[] src, String filter){
        ArrayList<String> filtered = new ArrayList<>();

        for (int i = 0; i < src.length; i++)
            if (src[i].startsWith(filter))
                filtered.add(src[i]);
    
        return filtered.toArray(new String[0]);
    }
    
    static String getLocalHostName() throws UnknownHostException {
        return InetAddress.getLocalHost().getCanonicalHostName().toLowerCase();
    }
    
    /**
     * Get free port number.
     *
     * @return Free port number
     */
    static int getFreePort() {
        try (ServerSocket server = new ServerSocket(0);) {
            return server.getLocalPort();
        } catch (Exception e) {
            logger.log(Level.INFO, "Unable to find a free port", e);
            return 0;
        }
    }
}